/*========================================================================
    Copyright (C) 1999  Ing Krippel Harald
    E-Mail: neuro.harald@surfeu.at

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

========================================================================*/

#include "ErrView.h"
#include "evolut.h"

long errorloop=1;

ErrView::ErrView(BRect rect, const char *name)
	   	   : BView(rect, name, B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_PULSE_NEEDED)
{	
	errgr_offx=10;
	errgr_offy=10;
	errgr_dx=200;
	errgr_dy=200;
	errgr_x=1;
	errgr_y_alt=0;
	SetFont(be_bold_font);
	SetFontSize(9);	
}

void ErrView::Pulse()
{
	BPoint point1;
	BPoint point2;

	if(mypop.generation < ERRSTEP)
	{
		errgr_max = mypop.rep->fitness;	
	}
	if(mypop.generation >= errorloop)
	{
		
		point1.Set(errgr_offx+errgr_x , errgr_offy+errgr_y_alt);
		errgr_y = errgr_dy - int((float)(errgr_dy)*do_skal(0, errgr_max, mypop.rep->fitness));
		point2.Set(errgr_offx+errgr_x+1 , errgr_offy+errgr_y);
		StrokeLine(point1, point2);
		errgr_y_alt=errgr_y;
		errgr_x ++;
		errorloop += ERRSTEP;
	}	
}

void ErrView::Draw(BRect)
{
	BPoint point1;
	BPoint point2;
	
	point1.Set(errgr_offx , errgr_offy);
	point2.Set(errgr_offx , errgr_offy+errgr_dy);
	StrokeLine(point1, point2);

	point1.Set(errgr_offx , errgr_offy+errgr_dy);
	point2.Set(errgr_offx+errgr_dx , errgr_offy+errgr_dy);
	StrokeLine(point1, point2);
}
