/*========================================================================
    Copyright (C) 1999  Ing Krippel Harald
    E-Mail: neuro.harald@surfeu.at

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

========================================================================*/

#include <stdio.h>
#include <string.h>
#include <Entry.h> 
#include <Path.h> 
#include <AppFileInfo.h>
#include <String.h>
#include <File.h>

#include "MainWindow.h"
#include "EvoNeuro.h"
#include "ErrWindow.h"
#include "evolut.h"

int32 mythreadfunc(void *data);
int32 mythreadpropfunc(void *data);

/* Globale Variablen */
POPULATION			mypop;
char data[512];
app_info ai;
thread_id mythread;
thread_id mythreadprop;
BString path_string;

int32 mythreadfunc(void *data)
{
//	thread_id sender;
//	int32 code;
//	char buf[512];
	
	while(1)
	{
		Do_Evolution(&mypop);		
	}	
}
int32 mythreadpropfunc(void *data)
{
//	thread_id sender;
//	int32 code;
//	char buf[512];
	
	while(1)
	{
		Do_Popprop(&mypop);		
	}	
}

main()
{	
	MainApplication	myApplication;
	
	app_info ai;
	BFile file;
	BAppFileInfo afi;
	BPath file_path;
	BPath parent;

	BString path_string_file;

	be_app->GetAppInfo(&ai);
	file.SetTo(&ai.ref, B_READ_WRITE);
	afi.SetTo(&file);
	BEntry entry(&ai.ref, FALSE);
	entry.GetParent(&entry);
	entry.GetPath(&file_path);


	mypop.size=POPSIZE;		// Anzahl der Lebewesen in der Population 30 10
	mypop.Eltanz=2;		// X Eltern zur Zeugung eunes Kindes
	mypop.nbest=BESTN;		// nbest werden unverndert bernommen
	mypop.maxgenera=MAXGEN;	// X Generationen sollen durchlaufen werden
	mypop.inUse = FALSE;
	mypop.inPause = FALSE;
	mypop.InitOK = FALSE;
	mypop.inUse = TRUE;
	mypop.inPause = FALSE;
	mypop.propthread = 0;
	
	path_string+=file_path.Path();
	path_string_file+=path_string.String();
	path_string_file+="/Daten";
	lade_daten(path_string_file.String());
	
	init_muster(&mypop);

	// thread aufrufen
	 mythread = spawn_thread(mythreadfunc,"harry",B_NORMAL_PRIORITY,(void *)data);
		// start thread
	resume_thread(mythread);
	// thread aufrufen
	 mythreadprop = spawn_thread(mythreadpropfunc,"harry",B_NORMAL_PRIORITY,(void *)data);
		// start thread
	resume_thread(mythreadprop);

	myApplication.Run();
	
	kill_thread(mythread);
	kill_thread(mythreadprop);
	
	return(0);
}

MainApplication::MainApplication()
		  		  : BApplication("application/x-vnd.Be-EvoNeuro")
{
	MainWindow		*aWindow;
	ErrWindow		*eWindow;
	BRect			aRect;

	GetAppInfo(&ai);
	// set up a rectangle and instantiate a new window
	aRect.Set(100, 80, 460, 120);
	aWindow = new MainWindow(aRect);
	aRect.Set(100, 160, 460, 420);
	eWindow = new ErrWindow(aRect);			
	// make window visible
	aWindow->Show();		
	eWindow->Show();		
	
}


